/********************************************************************************
*                                                                               *
* Copyright (c) 2007, Computer Networks and Internet, University of Tübingen,   *
* Sand 13, 72076 Tübingen, Germany                                              *
*                                                                               *
* All rights reserved.                                                          *
*                                                                               *
* This library is free software; you can redistribute it and/or                 *
* modify it under the terms of the GNU Lesser General Public                    *
* License as published by the Free Software Foundation; either                  *
* version 2.1 of the License, or (at your option) any later version.            *
*                                                                               *
* This library is distributed in the hope that it will be useful,               *
* but WITHOUT ANY WARRANTY; without even the implied warranty of                *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU              *
* Lesser General Public License for more details.                               *
*                                                                               *
* You should have received a copy of the GNU Lesser General Public              *
* License along with this library; if not, write to the Free Software           *
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA       *
*                                                                               *
********************************************************************************/
#ifndef LIBTIMING_H_
#define LIBTIMING_H_

#include <sys/time.h>

typedef struct _measurePoint
{
	struct timeval point;
	char* identifier;
	struct _measurePoint* next;
} measurePoint;

typedef struct _libTimingSession
{
	char* appName;
	char* dstFolder;
	int filehandle;
	struct timeval startTime;
	struct timeval endTime;
	
	measurePoint* first;
	measurePoint* last;
} libTimingSession;


libTimingSession* libtiming_init(char* appName, char* dstFolder);

void startMeasurement(libTimingSession* sess);
void measure(libTimingSession* sess, char* identifier);
void endMeasurement(libTimingSession* sess);

void libtiming_finish(libTimingSession* sess);

#endif /*LIBTIMING_H_*/
