/********************************************************************************
*                                                                               *
* Copyright (c) 2007, Computer Networks and Internet, University of Tübingen,   *
* Sand 13, 72076 Tübingen, Germany                                              *
*                                                                               *
* All rights reserved.                                                          *
*                                                                               *
* This library is free software; you can redistribute it and/or                 *
* modify it under the terms of the GNU Lesser General Public                    *
* License as published by the Free Software Foundation; either                  *
* version 2.1 of the License, or (at your option) any later version.            *
*                                                                               *
* This library is distributed in the hope that it will be useful,               *
* but WITHOUT ANY WARRANTY; without even the implied warranty of                *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU              *
* Lesser General Public License for more details.                               *
*                                                                               *
* You should have received a copy of the GNU Lesser General Public              *
* License along with this library; if not, write to the Free Software           *
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA       *
*                                                                               *
********************************************************************************/
#include "pdpRequesterFactory.h"


#include <syslog.h>

//C++ includes
#include <stdexcept>


// All available PDP request methods
//#include "pdpFileRequester.h"
#include "pdpSOAPRequester.h"
//#include "PDPSimpleRequester.h"
//#include "hannesPdpGsoapRequester.h"
//#include "BesterPdpRequester.h"


namespace pam_xacml {

/*****************************************************************************
 *** Factory for different Methods to Request Authorization Decision       ***
 *****************************************************************************/
PDPRequesterFactory::PDPRequesterFactory(PAMConfiguration* conf) {
	_conf = conf;
}

PDPRequester* PDPRequesterFactory::getPdpRequester(PAMConfiguration* conf) {
	switch (_conf->getPdpRequester()) {
/*		case FILE_PDP_REQUESTER   :
			return new PDPFileRequester(_conf);
		case SIMPLE_PDP_REQUESTER :
	    	return new PDPSimpleRequester(_conf);
	    	*/
		case SOAP_PDP_REQUESTER   :
	    		return new pdpSOAPRequester(_conf);
		//case HANNES_PDP_REQUESTER :
	    	//return new HannesPdpRequester(_conf);
/*		case BESTER_PDP_REQUESTER:
			return new BesterPdpRequester(_conf);
*/
		default:
			throw std::runtime_error("PDPRequesterFactory::getPdpRequester undefined pdpRequester");
	}
}


}
