/********************************************************************************
*                                                                               *
* Copyright (c) 2007, Computer Networks and Internet, University of Tübingen,   *
* Sand 13, 72076 Tübingen, Germany                                              *
*                                                                               *
* All rights reserved.                                                          *
*                                                                               *
* This library is free software; you can redistribute it and/or                 *
* modify it under the terms of the GNU Lesser General Public                    *
* License as published by the Free Software Foundation; either                  *
* version 2.1 of the License, or (at your option) any later version.            *
*                                                                               *
* This library is distributed in the hope that it will be useful,               *
* but WITHOUT ANY WARRANTY; without even the implied warranty of                *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU              *
* Lesser General Public License for more details.                               *
*                                                                               *
* You should have received a copy of the GNU Lesser General Public              *
* License along with this library; if not, write to the Free Software           *
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA       *
*                                                                               *
********************************************************************************/

#ifndef PDP_REQUESTER_FACTORY_H_
#define PDP_REQUESTER_FACTORY_H_

#include "pam_handler.h"
#include "PAMConfiguration.h"

namespace pam_xacml { 


/*****************************************************************************
 *** Abstract PDPRequester                                                 ***
 *****************************************************************************/
class PDPRequester {
	public:		
		PDPRequester(PAMConfiguration *conf) { _conf = conf; };
		virtual char* getPdpDecision(const char* xacmlRequest) = 0;//returns xacmlResponse
	
	protected:
		PAMConfiguration* _conf;
		
};

/*****************************************************************************
 *** Factory for different Methods to Request Authorization Decision       ***
 *****************************************************************************/
class PDPRequesterFactory {
	public:
		PDPRequesterFactory(PAMConfiguration *conf);//creates PDPRequester instances, based on configuration
		PDPRequester* getPdpRequester(PAMConfiguration* conf);
		
	protected:
		PAMConfiguration* _conf;
		
};

}

#endif
