/********************************************************************************
*                                                                               *
* Copyright (c) 2011, ThereSIS, Romain FERRARI,   								*
* Palaiseau, France                                              				*
*                                                                               *
* All rights reserved.                                                          *
*                                                                               *
* This library is free software; you can redistribute it and/or                 *
* modify it under the terms of the GNU Lesser General Public                    *
* License as published by the Free Software Foundation; either                  *
* version 2.1 of the License, or (at your option) any later version.            *
*                                                                               *
* This library is distributed in the hope that it will be useful,               *
* but WITHOUT ANY WARRANTY; without even the implied warranty of                *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU              *
* Lesser General Public License for more details.                               *
*                                                                               *
* You should have received a copy of the GNU Lesser General Public              *
* License along with this library; if not, write to the Free Software           *
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA       *
*                                                                               *
********************************************************************************/
#ifndef PDPSOAPREQUESTER_H_
#define PDPSOAPREQUESTER_H_

/* Default buffer size.  */
#ifndef BUFSIZ
# define BUFSIZ _IO_BUFSIZ
#endif
#define PAM_LDAP_PATH_CONF              "/etc/ldap.conf"
#define PAM_LDAP_PATH_ROOTPASSWD        "/etc/ldap.secret"

#define CHECKPOINTER(ptr) do { if ((ptr) == NULL) { \
    fclose(fp); \
    return PAM_BUF_ERR; \
} \
} while (0)

#include "pdpRequesterFactory.h"
#include "../PAMConfiguration.h"

//#include <ldap.h>
#include <stdio.h>
#include <syslog.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <string>
#include <stdexcept>

// REST Includes
#include "../restClient/include/restclient.h"

// SOAP Includes
//#include "PDPImplPortBinding.nsmap"
//#include "xacml_datatypes.h"
//#include "xacml.h"
//#include "xacml_i.h"

// DOM Includes
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/dom/DOM.hpp>
#include <xercesc/framework/StdOutFormatTarget.hpp>

using namespace xercesc_3_1;

namespace pam_xacml
{

class pdpSOAPRequester : public PDPRequester
{
private:
	int 	sockfd, portno, n;
	struct 	sockaddr_in serv_addr;
	struct 	hostent *server;

	typedef struct pam_ssd
	  {
	    char *base;
	    int scope;
	    char *filter;
	    struct pam_ssd *next;
	} pam_ssd_t;
        RestClient::response restRequest(std::string subject, std::string action, std::string resource);
//        int soapRequest(std::string subject, std::string action, std::string resource, bool SAML, ns11__XACMLAuthzDecisionResponse* response, struct soap* _soap);
        std::string outputXmlStream(DOMDocument* myDoc);
        std::string buildXmlRequest(std::string subject, std::string resource, std::string action);
        void xmlRestParseResponse(std::string response, std::string decision, std::string statusMsg, std::string statusCode, std::string *obligations);

public:
	pdpSOAPRequester(PAMConfiguration* conf);
	virtual ~pdpSOAPRequester();
	char* getPdpDecision(const char* xacmlRequest);
};

}

#endif /*PDPSOAPREQUESTER_H_*/
