/********************************************************************************
*                                                                               *
* Copyright (c) 2007, Computer Networks and Internet, University of Tübingen,   *
* Sand 13, 72076 Tübingen, Germany                                              *
*                                                                               *
* All rights reserved.                                                          *
*                                                                               *
* This library is free software; you can redistribute it and/or                 *
* modify it under the terms of the GNU Lesser General Public                    *
* License as published by the Free Software Foundation; either                  *
* version 2.1 of the License, or (at your option) any later version.            *
*                                                                               *
* This library is distributed in the hope that it will be useful,               *
* but WITHOUT ANY WARRANTY; without even the implied warranty of                *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU              *
* Lesser General Public License for more details.                               *
*                                                                               *
* You should have received a copy of the GNU Lesser General Public              *
* License along with this library; if not, write to the Free Software           *
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA       *
*                                                                               *
********************************************************************************/
/*
 * AttributeProvider.h
 *
 *  Created on: Jul 2, 2008
 *      Author: theide
 */

#ifndef ATTRIBUTEPROVIDER_H_
#define ATTRIBUTEPROVIDER_H_

#include <string>
#include <stdexcept>
#include <unistd.h>
#include <stdio.h>
#include <time.h>

namespace pam_xacml {

class AttributeProvider {
public:
	AttributeProvider(char* username, char* appName);
	virtual ~AttributeProvider();

	std::string getValue(std::string fieldname);
	std::string valueFromApplication(std::string appl);
private:
	std::string _username;
	std::string _appname;
	std::string _hostname;

	std::string getDate();
	std::string getTime();
	std::string getTimeZone();
};

}

#endif /* ATTRIBUTEPROVIDER_H_ */
;
