/********************************************************************************
*                                                                               *
* Copyright (c) 2007, Computer Networks and Internet, University of Tübingen,   *
* Sand 13, 72076 Tübingen, Germany                                              *
*                                                                               *
* All rights reserved.                                                          *
*                                                                               *
* This library is free software; you can redistribute it and/or                 *
* modify it under the terms of the GNU Lesser General Public                    *
* License as published by the Free Software Foundation; either                  *
* version 2.1 of the License, or (at your option) any later version.            *
*                                                                               *
* This library is distributed in the hope that it will be useful,               *
* but WITHOUT ANY WARRANTY; without even the implied warranty of                *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU              *
* Lesser General Public License for more details.                               *
*                                                                               *
* You should have received a copy of the GNU Lesser General Public              *
* License along with this library; if not, write to the Free Software           *
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA       *
*                                                                               *
********************************************************************************/
/*
 * XacmlRequestParser.h
 *
 *  Created on: 17.07.2008
 *      Author: theide
 */

#ifndef XACMLREQUESTPARSER_H_
#define XACMLREQUESTPARSER_H_

#include <string>
#include <stdexcept>

#include <vector>

//libxml2 includes
#include <libxml/tree.h>
#include <libxml/parser.h>
#include <libxml/xpath.h>
#include <libxml/xpathInternals.h>

#include "XacmlAttribute.h"
#include "XacmlRequestDocument.h"


namespace xacml {

using namespace std;

class XacmlRequestParser {
public:
	XacmlRequestParser();
	virtual ~XacmlRequestParser();

	XacmlRequestDocument parseDocument(string doc);
private:
	xmlXPathObjectPtr getObjPtr(xmlXPathContextPtr ctx, string xPathExpr);
	xmlNodeSetPtr getNodeFromXpath(xmlXPathContextPtr ctx, string xPathExpr);
	vector<XacmlAttribute*> getAttributesOf(xmlXPathContextPtr ctx, string section);
	string getSubjectCategory(xmlXPathContextPtr ctx);
};

}

#endif /* XACMLREQUESTPARSER_H_ */
