/********************************************************************************
*                                                                               *
* Copyright (c) 2007, Computer Networks and Internet, University of Tübingen,   *
* Sand 13, 72076 Tübingen, Germany                                              *
*                                                                               *
* All rights reserved.                                                          *
*                                                                               *
* This library is free software; you can redistribute it and/or                 *
* modify it under the terms of the GNU Lesser General Public                    *
* License as published by the Free Software Foundation; either                  *
* version 2.1 of the License, or (at your option) any later version.            *
*                                                                               *
* This library is distributed in the hope that it will be useful,               *
* but WITHOUT ANY WARRANTY; without even the implied warranty of                *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU              *
* Lesser General Public License for more details.                               *
*                                                                               *
* You should have received a copy of the GNU Lesser General Public              *
* License along with this library; if not, write to the Free Software           *
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA       *
*                                                                               *
********************************************************************************/
#ifndef PAM_XACML_H_
#define PAM_XACML_H_

#ifdef LIBSIM
// PAM Substitute for debugging
#include "tests/pam_facade.h"

#else

// PAM Includes
#ifdef __APPLE__
#ifdef __cplusplus
extern "C" {
#endif
	#include <pam/pam_modules.h>
	#include <pam/pam_misc.h>
	#include <pam/_pam_macros.h>
#ifdef __cplusplus
}
#endif
#else
	#include <security/pam_modules.h>
	#include <security/pam_misc.h>
	#include <security/_pam_macros.h>
#endif

#endif

// PAM-Specific defines
#define PAM_SM_AUTH
#define PAM_SM_ACCOUNT


/* PAM Library functions */
#ifdef LIBSIM
int pam_sm_authenticate(pam_handle_t *pamh, int flags, int argc, const char **argv);
int pam_sm_setcred(pam_handle_t *pamh, int flags, int argc, const char **argv);
int pam_sm_acct_mgmt(pam_handle_t *pamh, int flags, int argc, const char **argv);
#else
PAM_EXTERN int pam_sm_authenticate(pam_handle_t *pamh, int flags, int argc, const char **argv);
PAM_EXTERN int pam_sm_setcred(pam_handle_t *pamh, int flags, int argc, const char **argv);
PAM_EXTERN int pam_sm_acct_mgmt(pam_handle_t *pamh, int flags, int argc, const char **argv);
#endif


#endif /*PAM_XACML_H_*/
